class Missile{
  Timer timer;
  float x, y;
  int mSize;
  boolean bState;
  color c;
  void setColor(int r, int g, int b){
    c = color(r,g,b);
  }
  
  void move(){}
  
  void display(){
    stroke(0);
    fill(c);
    ellipse(x,y,mSize,mSize);
    move();
  }
}

class UserMissile extends Missile{
  UserMissile(int nX, int nY, int nowSize){
    x = nX;
    y = nY;
    mSize = nowSize;
    bState = true;
    timer = new Timer(10);
    timer.start();
    display();
  }
  void move(){
    if(timer.isFinished()){
      y-=5;
      timer.start();
    }
    if(y < 0){
      bState = false;
    }
  }
}

class MonsterMissile extends Missile{
  int missileSpeed = 0;
  MonsterMissile(int nowMissileSpeed){
    x = 0;
    y = 0;
    mSize = 0;
    bState = false;
    missileSpeed = nowMissileSpeed;
    timer = new Timer(10);
    timer.start();
    display();
  }
  void setUp(int nX, int nY, int nowSize){
    x = nX;
    y = nY;
    mSize = nowSize;
    bState = true;   
  }
  void move(){
    if(timer.isFinished()){
      setColor((int)random(255),(int)random(255),(int)random(255));
      y += missileSpeed;
      timer.start();
    }
    if( y > 430){
      bState = false;
    }
  }
  
  boolean isCheck(User u){
    if( u.y < y && y < 430){
      if( u.xSizeLeft < x && u.xSizeRight > x){
        return true;
      }  
    }
    return false;
  }
}

class MissileUser extends Missile{
  PImage mImage;
  
  MissileUser(int nowSize){
    x = width / 2 ;
    y = height /2;
    mSize = nowSize;
    //c = color(255,0,0);
    mImage = loadImage("air.png");
  }
  
  void move(){
    x = mouseX;
    y = mouseY;
    if(x < mSize) x = mSize;
    if(x > width ) x = width;
    if( y < mSize)  y = mSize;
    if( y > 430) y =430;
    image(mImage,x-12,y-20);
  }
  void display(){
    stroke(255);
    fill(255);
    ellipse(x,y,mSize,mSize);
    move();
  }
}

class MissileMonster extends Missile{
  float xSpeed , ySpeed;
  
  MissileMonster(int nowSize){
    x = random(width);
    y = random(430);
    mSize = nowSize;
    
    xSpeed = random(3);
    ySpeed = random(3);
  }
  void move(){
   //x += xSpeed + (( x- mouseX )* 0.01);
   //y += ySpeed +  (( y - mouseY )* 0.01);
   //x += x + (x * 0.98 + mouseX) + xSpeed;
   //y += y + (x * 0.98 + mouseX) + ySpeed;
   
   //x = x + (mouseX - x) *0.01;
   //y = y + (mouseY - y) *0.01;   
   
   x += xSpeed;
   y += ySpeed;

    if( x < 0 || x > width){
      xSpeed *= -1;
    }
    if( y < 0 || y > 430){
      ySpeed *= -1;
    }
  }
  boolean intersect(MissileUser uM){
    float distance = dist(x,y, uM.x, uM.y);
    if(distance < uM.mSize){
      return true;
    }else{
      return false;
    }
  }
}
